<?php
/*
Plugin Name: coComment Enhancer
Plugin URI: http://www.andare.ch/blog/tag/wordpress+cocomment
Description: Simply inserts the needed javascript to improve interaction with cocomment.com of your Wordpress blog
Author: David Reindl
Version: 1.0
*/

load_plugin_textdomain('coCommentEnhance', 'wp-content/plugins/cocomment_js/');

class coCommentEnhance {

	function option_page_coCommentEnh () {
	
		if(isset($_POST['Options'])) {
			$updCocOptions['toggle'] = $_POST['toggle'] == 1 ? true : false;
			$updCocOptions['toggleImg'] = $_POST['toggleImg'];
			
			update_option('coComment_Enhance', $updCocOptions);
			echo '<div class="updated"><p><strong>' . __('Options updated.', 'coCommentEnhance') . '</strong></p></div>';
		}
		
		$cocOptions = get_settings('coComment_Enhance');
		
		$ck_use_toggle = $cocOptions['toggle'] == true ? ' checked="checked"' : '';

		//Page Presentation
		echo '
			<div class="wrap">
				<h2>' . __('coComment Enhancer Settings', 'coCommentEnhance') . '</h2>
				<form method="post">
					<table width="100%" cellspacing="2" cellpadding="5" class="editform">
						<tr valign="top">
							<th width="33%" scope="row">' . __('Display Toggle Switch', 'coCommentEnhance') . ':</th>
							<td><input type="checkbox" name="toggle" id="toggle" ' . $ck_use_toggle . ' value="1" />&nbsp;' . __('Enable', 'coCommentEnhance') . '</td>
						</tr>
						<tr valign="top">
							<th width="33%" scope="row">' . __('Use switch image', 'coCommentEnhance') . ':</th>
							<td>
								<input type="text" name="toggleImg" id="toggleImg" size="80" value="' . $cocOptions['toggleImg'] . '" />
							</td>
						</tr>
						<tr valign="top">
							<th width="33%" scope="row">&nbsp;</th>
							<td>' . __('If you enable the toggle switch and leave this field empty, a textual switch will be display in place of an image.<br />(default is /wp-content/plugins/cocomment_js/cocomment-toggle.gif)', 'coCommentEnhance') . '</td>
						</tr>
					</table>
					<div class="submit"><input type="submit" name="Options" value="' . __('Update Options', 'coCommentEnhance') . ' &raquo;" /></div>
				</form>
			</div>
		';

	}

	function add_options() {
		add_option('coComment_Enhance',array('toggle' => true, 'toggleImg' => '/wp-content/plugins/cocomment_js/cocomment-toggle.gif'),'settings for the coComment Enhance plugin');
		return true;
	}

	function insert_coComment_js () {
		global $user_ID, $user_identity;
		$cocOptions = get_settings('coComment_Enhance');
		echo "\n"
		. "<!-- Script snippet to improve interaction with cocomment.com -->\n"
		. "<script type=\"text/javascript\">\n"
		. "var blogTool               = \"WordPress\";\n"
		. "var blogURL                = \"";
		echo get_option('siteurl');
		echo "\";\n"
		. "var blogTitle              = \"";
		bloginfo('name');
		echo "\";\n"
		. "var postURL                = \"";
		the_permalink();
		echo "\";\n"
		. "var postTitle              = \"";
		the_title();
		echo "\";\n";
		if ( $user_ID ) {
			echo "var commentAuthor          = \"";
			echo $user_identity;
			echo "\";\n";
		} else {
			echo "var commentAuthorFieldName = \"author\";\n";
		}
		echo "var commentAuthorLoggedIn  = ";
		if ( !$user_ID ) { echo "false"; }
		else { echo "true"; };
		echo ";\n";
		echo "var commentFormID          = \"commentform\";\n";
		echo "var commentTextFieldName   = \"comment\";\n";
		echo "var commentButtonName      = \"submit\";\n";
		echo "var cocomment_force = false;\n";
		echo "\n";
		echo "</script>\n";
		echo "\n"
		. "<script type=\"text/javascript\" src=\"http://www.cocomment.com/js/cocomment.js\" ></script>\n";
		
		if ($cocOptions['toggle']) {
			echo "<script type=\"text/javascript\">\n"
			. "\tvar coToggleSpan = document.createElement(\"span\");\n"
			. "\tcoToggleSpan.id = \"cocomment-toggle\";\n"
			. "\tvar coToggleA = document.createElement(\"a\");\n"
			. "\tcoToggleA.href = \"#\";\n"
			. "\tvar coToggleImg = document.createElement(\"img\");\n"
			. "\tcoToggleImg.src = \""
			. get_option('siteurl') . $cocOptions['toggleImg'] . "\";\n"
			. "\tcoToggleImg.alt = \"toggle cocomment\";\n"
			. "\tcoToggleImg.width = \"80\";\n"
			. "\tcoToggleImg.border = \"0\";\n"
			. "\tcoToggleImg.height = \"15\";\n"
			. "\tcoToggleImg.onclick = function() {cocomment_toggle();return false};\n"
			. "\tcoToggleA.appendChild(coToggleImg);\n"
			. "\tcoToggleSpan.appendChild(coToggleA);\n"
			. "\tvar coCurrent = document.getElementById('commentform').submit;\n"
			. "\tcoCurrent.parentNode.insertBefore(coToggleSpan, coCurrent.nextSibling);\n"
			. "</script>\n";
		}
	
	}

	function admin_menu($not_used) {
		if (function_exists('add_options_page')) {
			add_options_page('coComment a', 'coComment Enhancer', 5, 'cocomment_js/' . basename(__FILE__), array('coCommentEnhance', 'option_page_coCommentEnh'));
		}

	}

}

if (intval(substr(get_bloginfo('version'), 0, 1)) >= 2 ) {
	register_activation_hook('cocomment_js/' . basename(__FILE__), array('coCommentEnhance', 'add_options'));
}
add_action('admin_menu', array('coCommentEnhance', 'admin_menu'));
add_action('comment_form', array('coCommentEnhance', 'insert_coComment_js'));
